/* $Id: sdl_s.c 3552 2006-02-05 09:56:04Z tron $ */

#include "../stdafx.h"

#ifdef WITH_SDL

#include "../openttd.h"
#include "../driver.h"
#include "../mixer.h"
#include "../sdl.h"
#include "sdl_s.h"
#include <SDL.h>
//DKS
#include <SDL_mixer.h>

//DKS
/*
static void CDECL fill_sound_buffer(void *userdata, Uint8 *stream, int len)
{
	MxMixSamples(stream, len / 4);
}
*/
static void CDECL fill_sound_buffer(void *udata, Uint8 *stream, int len)
{
	MxMixSamples(stream, len / 4);
}

//DKS
/*
static const char *SdlSoundStart(const char * const *parm)
{
	SDL_AudioSpec spec;

	const char *s = SdlOpen(SDL_INIT_AUDIO);
	if (s != NULL) return s;

	spec.freq = GetDriverParamInt(parm, "hz", 11025);
	spec.format = AUDIO_S16SYS;
	spec.channels = 2;
	spec.samples = 512;
	spec.callback = fill_sound_buffer;
	SDL_CALL SDL_OpenAudio(&spec, &spec);
	SDL_CALL SDL_PauseAudio(0);
	return NULL;
}
*/
static const char *SdlSoundStart(const char * const *parm)
{
	const char *s = SdlOpen(SDL_INIT_AUDIO);
	if (s != NULL) return s;

	//DKS - changing to 256 to fix GP2X sound lag
	//SDL_CALL Mix_OpenAudio(22050, AUDIO_S16LSB, 2, 512);
	SDL_CALL Mix_OpenAudio(22050, AUDIO_S16LSB, 2, 512);
	SDL_CALL Mix_SetPostMix(fill_sound_buffer, NULL);
	return NULL;
}

//DKS
/*
static void SdlSoundStop(void)
{
	SDL_CALL SDL_CloseAudio();
	SdlClose(SDL_INIT_AUDIO);
}
*/
static void SdlSoundStop(void)
{
	SDL_CALL Mix_CloseAudio();
	SdlClose(SDL_INIT_AUDIO);
}



const HalSoundDriver _sdl_sound_driver = {
	SdlSoundStart,
	SdlSoundStop,
};

#endif
